package com.trafficparrot.sdk.handlebars;

import com.github.jknack.handlebars.Options;
import com.google.common.base.Optional;

import java.io.IOException;

public class IfEven extends TrafficParrotHelper<Object> {
    @Override
    protected Object doApply(Object object, Options options) throws IOException {
        Optional<Integer> integer = toInteger(object);
        if (!integer.isPresent()) {
            return "{{ Warning: '" + object + "' is not an integer }}";
        }
        if (isEven(integer.get())) {
            return options.fn();
        } else {
            return options.inverse();
        }
    }

    private boolean isEven(int number) {
        return number % 2 == 0;
    }

    private Optional<Integer> toInteger(Object object) {
        if (object instanceof Integer) {
            return Optional.of((Integer) object);
        }
        try {
            return Optional.of(Integer.valueOf(object.toString()));
        } catch (NumberFormatException e) {
            return Optional.absent();
        }
    }
}
