//package com.trafficparrot.sdk.ibmmq;
//
//
//import com.trafficparrot.sdk.jms.Destination;
//import com.trafficparrot.sdk.jms.Slf4jTpLogger;
//import com.trafficparrot.sdk.jms.TpLogger;
//
//import static com.trafficparrot.sdk.ibmmq.IbmMqResponse.NO_TRANSFORMER;
//import static java.lang.String.format;
//
//public abstract class IbmMqResponseTransformer {
//    protected final TpLogger logger;
//
//    public IbmMqResponseTransformer() {
//        this(new Slf4jTpLogger(IbmMqResponseTransformer.class));
//    }
//
//    public IbmMqResponseTransformer(TpLogger logger) {
//        this.logger = logger;
//    }
//
//    public final IbmMqResponse transform(Destination requestDestination, MQMessage requestMessage, IbmMqResponse response) {
//        try {
//            IbmMqResponse ibmMqResponse = doTransform(requestDestination, requestMessage, response);
//            if (!NO_TRANSFORMER.equals(ibmMqResponse.ibmMqResponseTransformerClassName)) {
//                String errorMessage = format("Please set the ibmMqResponseTransformerClassName to %s in %s (it was set to %s)", NO_TRANSFORMER, getClass().getCanonicalName(), ibmMqResponse.ibmMqResponseTransformerClassName);
//                logger.error(errorMessage);
//                return new IbmMqResponse(response.destination,  errorMessage);
//            }
//            return ibmMqResponse;
//        } catch (Exception e) {
//            String errorMessage = format("%s had a problem while transforming: %s", getClass().getCanonicalName(), e.getMessage());
//            logger.error(errorMessage, e);
//            return new IbmMqResponse(response.destination, errorMessage + ". See logs for more details.");
//        }
//    }
//
//    protected abstract IbmMqResponse doTransform(Destination requestDestination, MQMessage requestMessage, IbmMqResponse response) throws Exception;
//
//    public String getDisplayName() {
//        return getClass().getSimpleName();
//    }
//}
